-- ----------------------------------------------------------------
-- 経路ユーザーのビュー
-- ----------------------------------------------------------------
CREATE FUNCTION recreate_routeuser_view() RETURNS void AS $$
DECLARE
    view_name VARCHAR;
    app_id    NUMERIC(6,0);
BEGIN
    SELECT ID INTO app_id FROM TM_CDB_APP WHERE type_='flowview';
    IF app_id is not null THEN
        view_name := 't' || right('000000' || CAST(app_id AS VARCHAR), 6) || '000c00058';
        EXECUTE 'DROP VIEW ' || view_name;
        EXECUTE 'CREATE VIEW ' || view_name || ' AS SELECT' ||
          ' users.ID AS key_ ,' ||
          ' row_number() OVER (PARTITION BY users.ID ORDER BY users.SID_USER_ROUTE) AS seqno ,' ||
          ' users.SID_USER_ROUTE AS user_id FROM (' ||
          'SELECT ID, SID_USER_ROUTE FROM TT_FLW_ROUTE WHERE SID_USER_ROUTE>0 UNION ' ||
          'SELECT ID, SID_USER_ROUTE FROM TT_FLW_ROUTE_GROUP_USER UNION ' ||
          'SELECT ID, SID_USER AS SID_USER_ROUTE FROM TT_FLW_READER UNION ' ||
          'SELECT ID, entry AS SID_USER_ROUTE FROM TT_FLW_NOTICE WHERE SID_ROUTE>0 AND entry>0 UNION ' ||
          'SELECT ID, entry AS SID_USER_ROUTE FROM TT_FLW_NOTICE_POOL WHERE entry>0' ||
          ') users';
    END IF;
END;
$$ LANGUAGE plpgsql;
select recreate_routeuser_view();
DROP FUNCTION recreate_routeuser_view();
